@echo off
rem Script: setup.cmd
rem Title:  Script start executable setup jar
rem Author: oliver.haufe@sos-berlin.com

set PARAM_XML_FILE=%~f1
set TMPFILE=%TEMP%\sos_jobscheduler_setup%RANDOM%.txt
set REG_RESULT=
set JRE_HOME=
set /A JAVA_VERSION=0

rem check wether reg.exe in path
reg.exe >nul 2>nul
if %ERRORLEVEL% equ 9009 goto start_setup

rem looking for current JRE in registry key "HKLM\SOFTWARE\JavaSoft\Java Runtime Environment"
call :search_jre

:start_setup
if not defined PARAM_XML_FILE (
  start "JobSchedulerSetup" "%JRE_HOME%javaw.exe" -jar "%~dp0jobscheduler_windows-x64_update.1.9.4.jar"
) else (
  call :check_java_version
  "%JRE_HOME%java.exe" -jar "%~dp0jobscheduler_windows-x64_update.1.9.4.jar" "%PARAM_XML_FILE%"
)
goto final

:check_java_version
@rem check if java version at least 1.8
for /F "usebackq tokens=3" %%a in (`"%JRE_HOME%java.exe" -version 2^>^&1`) do (
  for /F "delims=. tokens=1,2" %%i in ( "%%~a" ) do (
    set /A JAVA_VERSION=%%i*10000+%%j
    goto check_java_version2
  )
)
:check_java_version2
if defined JAVA_VERSION (
  if %JAVA_VERSION% LSS 10008 (
    echo ... the java version of "%JRE_HOME%java.exe" is less than 1.8.x
    echo ... please install a java runtime environment at least 1.8.x
    exit 1
  )
)
goto final

:search_jre
call :reg_query "%~1" "" CurrentVersion
if defined REG_RESULT call :reg_query "%~1" "\%REG_RESULT%" JavaHome
if defined REG_RESULT call :set_jre "%REG_RESULT%"
goto final

:reg_query
reg.exe QUERY "HKLM\SOFTWARE\%~1JavaSoft\Java Runtime Environment%~2" 2>nul | %windir%\System32\find /I "%~3" > "%TMPFILE%"
for /F "usebackq tokens=2*" %%i in ("%TMPFILE%") do call :reg_result "%%j"
del "%TMPFILE%"
goto final

:reg_result
set REG_RESULT=%~1
goto final

:set_jre
if "%~1"=="" goto final
if not exist "%~1" goto final
set JRE_HOME=%~1\bin\
goto final

:final